/* C Source File
Note to the english users:the commentary are only in french:)
Created 04/02/05; 16:12:18
						DEMINE V0.6 par C.Gallet
contact caam_g@hotmail.com
certaines parties du programme sont inspirs par:
	'Queue' de Kurt Hoffmann(hoffmann@purdue.edu)
  'zzmouse' de Nicolas Pourcelot
   les exemples fournis avec TIGCC*/

#define MIN_AMS 200//definie la version minimale d'OS ncessaire(ici 2.00)
#include <tigcclib.h>
#include "extgraph.h"
#define _92P  //remplacer par _92P ou _V200 pour avoir 1 version pour 92+
#define _francais  //replace by _english to have an english version

#if    defined(_francais) && defined(_english)
#error Cannot produce a program in 2 languague at once
#elif defined(_francais)
#define _fr_eng(x, y) (x)
#elif defined(_english)
#define _fr_eng(x, y) (y)
#else
#error You must defined _francais or _english
#endif

#define MESSAGE _fr_eng("Programm par C.Gallet","Programmed by C.Gallet")
#define AUTEUR "Camille Gallet"
#define PROTEC_NB 45

#if    defined(_89) && defined(_92P) \
    || defined(_89) && defined(_V200)
#error Cannot produce both versions at once
#elif defined(_89)//  An idea I copied in Flib source
int _ti89;
#define _89_92(x, y) (x)
//If it's a TI89,then this fonction will return the 2nd argument
#elif defined(_92P) || defined(_V200)
int _ti92plus;
int _v200;
#define _89_92(x, y) (y)
#else
#error You must defined _89 or _92
#endif


int *dem,*tab_info;//declare 2 tableaux dynamiques
#define dem ((int (*)[nbr_colonne])dem)
#define tab_info ((int (*)[nbr_colonne])tab_info)
volatile int Counter=0,count2=0;
int nbr_colonne=1;
int nbr_ligne=1;
int nombre_mines=1;
short key;
short redo=0;
short score,difficulte,nb_de_drapeaux;
short x;
short y;
static short key_enter=KEY_ENTER,key_esc=KEY_ESC,key_off=KEY_OFF,key_off2,key_up,key_down;

INT_HANDLER OldInt5 = NULL;
LCD_BUFFER ecran;
SCR_RECT ECRAN = {{0, 0, _89_92(159,239), _89_92(99,127)}};

enum highscore_option {WRITE,READ};

unsigned char case_dark[] = {
0x02,0x02,0x02,0x02,0x02,0x02,0xFE
};//la case pour le plan fonc
unsigned char case_light[] = {
0x00,0x7E,0x7E,0x7E,0x7E,0x7E,0x7E
};//la case pour le plan clair
unsigned char case_mask[] = {
~(char)0xFE,~(char)0xFE,~(char)0xFE,~(char)0xFE,
~(char)0xFE,~(char)0xFE,~(char)0xFE,~(char)0xFE
};//le masque
unsigned char case_inverse_dark[] = {
0x02,0x00,0x02,0x00,0x02,0x00,0xAA
};//la case clique pour le plan fonce
unsigned char case_inverse_light[] = {
0xFC,0xFE,0xFC,0xFE,0xFC,0xFE,0x54
};//la case clique pour le plan clair

typedef struct {
	char nom[10];
	int temps;
}RECORD;//structure pour stocker les records

RECORD record_debutant[3];
RECORD record_intermediaire[3];
RECORD record_expert[3];

DEFINE_INT_HANDLER(MyInt5)//le chrono
{
  count2++;
  if (count2 == 20)//1 interuption s'execute environ 20 fois/s
  {
    Counter++;
    count2=0;
  }
  ExecuteHandler (OldInt5);
}

void _main (void);//1 prototype necessaire pour 'quit'
///////////////////////////////////////////////////////////////////////////////////
void status(void)//ecris des informations dans la 'status line'
{
   char status_message[50];
	 short i;
   FontSetSys(F_4x6);
   sprintf(status_message,"%dmines/%d %dmin%ds  ",nb_de_drapeaux,nombre_mines,(Counter-(Counter%60))/60,Counter%60);
	 for (i=0 ; i<2 ;i++)
	 {
	 	 GraySetAMSPlane(i);
	   DrawStr(50,_89_92(94,122),status_message,A_REPLACE);
	 }
   FontSetSys(F_6x8);
}

/////////////////////////////////////////////////////////////////////////////////////
void Input(char *buffer,unsigned short imax)//1 'scanf' amelior
{
  SCR_STATE ss;
  short key;
  unsigned short i = 0;
  char save_buffer[10];
  strcpy(save_buffer,buffer);
  buffer[0] = 0;
  SaveScrState (&ss);
  do
    {
      MoveTo (ss.CurX, ss.CurY);
      printf ("%s_ ", buffer);
      idle();
      key = ngetchx ();
      if ((key >= '0' && key <= '9') && (i<3) && (i<imax))
        buffer[i++] = key;
      else if (key == KEY_BACKSPACE && i)//efface le caractre
        i--;
      buffer[i] = 0;
    } while (((key != key_enter) && (key != key_esc)) || (key==key_enter && i==0));
    if ((key == key_esc) || (is_nan(atoi(buffer))))
      strcpy(buffer,save_buffer);
  MoveTo (ss.CurX, ss.CurY);
  printf ("%s   ", buffer);
}

/////////////////////////////////////////////////////////////////////////////////////
void DrawStrVert(char *str,short x,short y,short font)//Ecris du texte verticalement
{
  FontSetSys(font);
	unsigned short  width=strlen(str);
	unsigned short i,len=10;
	if (font == F_4x6)
	  len=6;
	if (font == F_6x8)
	  len=8;
	for (i=0 ; i<width ; i++)
	  DrawClipChar(x,y+(i*len),str[i],&ECRAN,A_REPLACE);
  FontSetSys(F_6x8);
}

/////////////////////////////////////////////////////////////////////////////////////
void input_str(char *str,int x,int y,int maxlen)//inspir par Queue
{
  int i=0,key=0;
  while(key!=13)
  {
    str[i]='_'; str[i+1]=' '; str[i+2]=0;
    DrawStr(x,y,str, A_REPLACE);
    idle();
    key=ngetchx();
    if(key>=' '&&key<='~'&&i<maxlen)
      str[i++]=key;
    else if ((key == key_off) || (key == key_off2))
      off();   // teint la calculatrice
    if(key==KEY_BACKSPACE&&i) i--;
  }
  str[i]=0;
}

//////////////////////////////////////////////////////////////////////////////////////
void afficher_records(void)
{
  clrscr();
  char msg[10];
  short key=0;
  strcpy(msg,"Records");
  DrawStrVert(msg,90,15,F_8x10);
  DrawClipRect(&(WIN_RECT){85,10,103,85},&ECRAN,B_ROUNDED | B_DOUBLE | A_NORMAL);
  FontSetSys(F_6x8);
  MoveTo(0,0);
	printf(_fr_eng("\nDbutant:\n","\nBeginner:\n"));
  FontSetSys(F_4x6);
	printf("%s   %u s\n%s   %u s\n%s   %u s\n",
	record_debutant[0].nom,record_debutant[0].temps,record_debutant[1].nom,record_debutant[1].temps,record_debutant[2].nom,record_debutant[2].temps);
  FontSetSys(F_6x8);
	printf(_fr_eng("Intermdiaire:\n","Intermediate:\n"));
  FontSetSys(F_4x6);
	printf("%s   %u s\n%s   %u s\n%s   %u s\n",
	record_intermediaire[0].nom,record_intermediaire[0].temps,record_intermediaire[1].nom,record_intermediaire[1].temps,record_intermediaire[2].nom,record_intermediaire[2].temps);
  FontSetSys(F_6x8);
	printf("Expert:\n");
  FontSetSys(F_4x6);
	printf("%s   %u s\n%s   %u s\n%s   %u s",
	record_expert[0].nom,record_expert[0].temps,record_expert[1].nom,record_expert[1].temps,record_expert[2].nom,record_expert[2].temps);
	while((key != key_enter) && (key != key_esc)) key=ngetchx();
}

///////////////////////////////////////////////////////////////////////////////////////
void help(void)
{
  SetIntVec (AUTO_INT_5, OldInt5);//dsactive le chrono...
  unsigned char arow_ASCII[4]={21,22,23,24},diam=127,text[200];
  LCD_BUFFER scr_light,scr_dark;  // Declares a buffer
  //quand les niveaux de gris sont activs LCD_Save & LCD_restore ne fonctionnent pas
	FastCopyScreen_R(GetPlane(DARK_PLANE),scr_dark);// Saves the screen inside buffer
  FastCopyScreen_R(GetPlane(LIGHT_PLANE),scr_light);
  sprintf(text,
  _fr_eng("%c%c%c%c:pour deplacer le pointeur\n[ESC]:quitte le jeu\n[%c]/[2nd]+[ON]:eteins la calculatrice\n[F1]:met 1 drapeaux\n[ENTER]:decouvre 1 case",
"%c%c%c%c:to move the mouse\n[ESC]:quit the game\n[%c]/[2nd]+[ON]:turn the calculator off\n[F1]:put a flag\n[ENTER]:show on a box"),
  arow_ASCII[0],arow_ASCII[1],arow_ASCII[2],arow_ASCII[3],diam);
  //DlgMessage("Aide",text,BT_NONE,BT_NONE);
  //DlgMessage ne fonctionne pas non plus avec les niveaux de gris donc:
  WINDOW help_light,help_dark;//il faut dessiner la fenetre en noir
  WIN_RECT win_perdu={10, 20, 150, 65};
  GraySetAMSPlane(LIGHT_PLANE);
	 	WinOpen (&help_light, &win_perdu , WF_TTY | WF_NOBOLD | WF_ROUNDEDBORDER | WF_TITLE,"AIDE");
		WinActivate (&help_light);
		WinFont(&help_light, F_4x6);
		WinStr (&help_light, text);
  GraySetAMSPlane(DARK_PLANE);
	 	WinOpen (&help_dark, &win_perdu, WF_TTY | WF_NOBOLD | WF_ROUNDEDBORDER | WF_TITLE,"AIDE");
		WinActivate (&help_dark);
		WinFont(&help_dark, F_4x6);
		WinStr (&help_dark, text);
  idle();
  ngetchx ();
  WinClose (&help_light);
  WinClose (&help_dark);
  ClrScr();
  FastCopyScreen_R(scr_dark,GetPlane(DARK_PLANE));
  FastCopyScreen_R(scr_light,GetPlane(LIGHT_PLANE));
  SetIntVec (AUTO_INT_5, MyInt5);//et le ractive...

}

////////////////////////////////////////////////////////////////////////////////////
void about(void)//informatin sur le programme
{
  char msg[50];
  static LCD_BUFFER virtuel;
	ClrScr();
  FontSetSys(F_8x10);
 PortSet(virtuel,239,127);//set up the virtual screen
  sprintf(msg,"DEMINE V0.6 %c3",(char)129);//char(129) = letre grecque bta
  DrawStr(20,0,msg,A_NORMAL);
  FontSetSys(F_4x6);
  DrawClipLine(&(WIN_RECT){0,13,240,13},&ECRAN,A_NORMAL);
  DrawClipLine(&(WIN_RECT){0,_89_92(84,112),240,_89_92(84,112)},&ECRAN,A_NORMAL);
  DrawStr(5,86,"Auteur : Camille Gallet",A_NORMAL);
  DrawStr(30,92,"e-mail : caam_g@hotmail.com",A_NORMAL);
  MoveTo(0,15);
	printf(
_fr_eng("Ce jeu est 1 demineur classique.
Le but est de decouvrir toute les cases n'tant
pas mins (pour 'cliquer' sur la case : [ENTER])
le nb indique le nb mines presentes autour
de la case (pour poser un drapeaux-indiquant
une mine-il faut utiliser [F1]).En appuyant sur
[APPS] ces touches sont affichs de nouveaux.

1 grand merci  _Kurt Hoffman( pour Queue),
                _Zeljko Jurik( pour sa librairie)
                _Nicolas Pourcelot (pour zzmouse)",
"This game is a clasic minesweeper.
The goal is to to reveal all boxes wich are not
mine (to 'clic' on box : press [ENTER])
the nb show the nb of mines wich are around
the box (to put a flag-showing a mine-you can
use the [F1] key).By pressing on [APPS]
those keys will be put on screen again.

Special thanks to _Kurt Hoffman( for Queue),
                _Zeljko Jurik( for his librairy)
                _Nicolas Pourcelot (for zzmouse)"
	));//affiche les informations
  FastCopyScreen_R(virtuel,LCD_MEM);
	idle();
  ngetchx();//attend que l'on appuie sur 1 touche
	PortRestore();
}

////////////////////////////////////////////////////////////////////////////////////
void highscore(BOOL lire)//lit ou ecrit les records dans 1 fichier externe
{
	FILE *fichier;
	short i=0;
  if (!lire)//ecris
  {
    EM_moveSymFromExtMem($(dem_scor), HS_NULL);//desarchive le fichier
  	fichier=fopen ("dem_scor", "wb");
  	i=PROTEC_NB;
  	fwrite(&i,sizeof(int),1,fichier);//protege le fichier
  	fwrite(record_debutant,sizeof(RECORD)*3,1,fichier);
  	fwrite(record_intermediaire,sizeof(RECORD)*3,1,fichier);
  	fwrite(record_expert,sizeof(RECORD)*3,1,fichier);
  	fwrite(&nbr_colonne,sizeof(int),1,fichier);
  	fwrite(&nbr_ligne,sizeof(int),1,fichier);
  	fwrite(&nombre_mines,sizeof(int),1,fichier);
 	  fputc (0, fichier);
    fputs ("DEMH", fichier);
    fputc (0, fichier);
    fputc (OTH_TAG, fichier);
    fclose (fichier);
    EM_moveSymToExtMem($(dem_scor), HS_NULL);//archive le fichier
  }else{//lire
  	fichier = fopen ("dem_scor", "rb");
  	if (fichier != NULL)
  	{
  	 	fread(&i,sizeof(int),1,fichier);
  	 	if (i == PROTEC_NB)//si c'est 1 fichier cre par le programme
  	 	{
    	 	fread(record_debutant,sizeof(RECORD)*3,1,fichier);
    	  fread(record_intermediaire,sizeof(RECORD)*3,1,fichier);
  	    fread(record_expert,sizeof(RECORD)*3,1,fichier);
		  	fread(&nbr_colonne,sizeof(int),1,fichier);
		  	fread(&nbr_ligne,sizeof(int),1,fichier);
		  	fread(&nombre_mines,sizeof(int),1,fichier);
  	  }
  	}
    fclose (fichier);
  }
}

////////////////////////////////////////////////////////////////////////////////////
void create(void)//creer 1 matrice alatoire
{
  int i,j;
	short x2,y2;
  signed int k,l;
  //alloue la memoire
	dem = calloc (nbr_ligne, sizeof (*dem));
	tab_info = calloc (nbr_ligne, sizeof (*tab_info));
	for (i=0 ; i< nbr_ligne ; i++)
	  for (j=0 ; j<nbr_colonne ; j++)
	  {
	  	dem[i][j]=0;
	  	tab_info[i][j]=0;
	  }
	for (i=0 ; i<nombre_mines ; i++)
	{
		x2=random(nbr_ligne);
		y2=random(nbr_colonne);
		if (dem[x2][y2]==0)
		  dem[x2][y2]=9;
		else
		  i--;
	}
	for (i=0 ; i<nbr_ligne ; i++)
		for (j=0 ; j<nbr_colonne ; j++)
	    if(dem[i][j]!=9)
	      for (k=-1 ; k<=1 ;k++)
	     	 	for(l=-1 ; l<=1 ; l++)
	     	 	{
	          if ((i+k<0) || (i+k>=nbr_ligne) || (j+l<0) || (j+l>=nbr_colonne))//si hors-limite
	            continue;//passe  la suite
	          if (dem[i+k][j+l]==9)
	     	 	    dem[i][j]++;
	     	 	}
	ClrScr();
}
//////////////////////////////////////////////////////////////////////////////////////
void mouse(void)//inspir par zzmouse de Nicolas Pourcelot
{
	short delai, delai_init,xx=x,yy=y;
  void *kbq = kbd_queue ();
  static unsigned char sprite[] = {0x80,0xC0,0xA0,0x90,0x88,0x84,0x82,0x81,
  0x87,0xA4,0xD4,0x12,0x0A,0x09,0x06};//the pointer
  static unsigned char imask[] = {~0x00,~0x00,~0x40,~0x60,~0x70,~0x78,~0x7C,~0x7E,
  ~0x78,~0x58,~0x08,~0x0C,~0x04,~0x06,~0x00};//the mask

  unsigned char RepetitionFlag;
  unsigned char LCDRecoverBuffer_light[16],LCDRecoverBuffer_dark[16];  // Declares a buffer

  delai_init = OSInitKeyInitDelay (10);  // Sets the initial autorepeat key delay.
  delai = OSInitBetweenKeyDelay(5);    //Sets the rate at which a key autorepeats.
	//lorseque les NVG sont actifs LCD_save et LCD_restore ne fonctionne pas
  Sprite8Get_R(x ,y ,15, GetPlane(DARK_PLANE),LCDRecoverBuffer_dark);
  Sprite8Get_R(x ,y ,15, GetPlane(LIGHT_PLANE),LCDRecoverBuffer_light);
  do
  {
		GraySprite8_MASK_R(xx, yy, 15, LCDRecoverBuffer_dark, LCDRecoverBuffer_light, LCDRecoverBuffer_dark, LCDRecoverBuffer_light, GetPlane(1), GetPlane(0));
  	Sprite8Get_R(x ,y ,15, GetPlane(DARK_PLANE),LCDRecoverBuffer_dark);
 		Sprite8Get_R(x ,y ,15, GetPlane(LIGHT_PLANE),LCDRecoverBuffer_light);
		xx=x;yy=y;
		GraySprite8_MASK_R(x, y, 15, sprite, sprite, imask, imask, GetPlane(0), GetPlane(1));
	  //Sprite is faster way than BitmapPut.
	  key = 0;
	  RepetitionFlag = 0;

	  while (OSdequeue (&key, kbq))
		{
	    status();
  		GraySprite8_MASK_R(x, y, 15, sprite, sprite, imask, imask, GetPlane(0), GetPlane(1));
			if (OSTimerExpired (APD_TIMER))
			{
		  	off();
			  OSInitKeyInitDelay (10);  // Sets the initial autorepeat key delay.
		  	OSInitBetweenKeyDelay(5) ;    //Sets the rate at which a key autorepeats.
		   	OSTimerRestart(APD_TIMER);		// Reset APD Timer to its initial value
			}
		}
		OSTimerRestart(APD_TIMER);

		 if (((key <= 6492)&&(key>=6481))
		     ||((key <= 18778)&&(key>=18769))
		     ||((key <= 2396)&&(key>=2385)))
		 {
			 RepetitionFlag = 1;	// The key was already pressed just before.
			 key -= 2048;
		 }
	   // TIOS add 2048 (0x800) to pressed key code in case of repetition.
	   //  changes the cursor position
	   if (key == key_up || (key == 339) || (key == KEY_UPRIGHT))  y --;
	   if (key == KEY_RIGHT || (key == 348) || (key == KEY_UPRIGHT))  x ++;
	   if (key == key_down || (key == 348) || (key == KEY_DOWNLEFT))  y ++;
	   if (key == KEY_LEFT || (key == 339) || (key == KEY_DOWNLEFT))  x --;


		if (RepetitionFlag == 1)		// if key was already pressed just before.
	   {
		  if (x <= 1 ) x = 1;      //   so, the cursor can't go away
		  if (y <= 1 ) y = 1;
		  if (x > nbr_ligne*7) x = nbr_ligne*7;
      if (y > nbr_colonne*7) y = nbr_colonne*7;
		 }
		else												// else, ...
		{
			if (x < 1 ) x = nbr_ligne*7;//   so, the cursor can't go away
			if (y < 1 ) y = nbr_colonne*7;
			if (x > nbr_ligne*7 ) x = 1;
			if (y > nbr_colonne*7) y = 1;
		}


	   if ((key == key_off) || (key == key_off2))
	   {
	      off();   // Turns the calculator off
	   		OSInitKeyInitDelay (10);  // Sets the initial autorepeat key delay.
	   		OSInitBetweenKeyDelay(5) ;    //Sets the rate at which a key autorepeats.
	   		/*
	   		This is due to TIOS behaviour :
	   		after the calc is turned on, these delays are automatically set to their
	   		default values.
	   		*/

	   }
  }while ((((key >= 337) && (key <= 348)) || (key == key_off) || (key == key_off2)));

	GraySprite8_MASK_R(xx, yy, 15, LCDRecoverBuffer_dark, LCDRecoverBuffer_light, LCDRecoverBuffer_dark, LCDRecoverBuffer_light, GetPlane(1), GetPlane(0));
	OSInitKeyInitDelay (delai_init);       // Restores initial parameters
  OSInitBetweenKeyDelay(delai);

}

///////////////////////////////////////////////////////////////////////////////////
void draw_box(short ligne,short colonne,char texte)//dessinne une case
{
  FontSetSys(F_4x6);
  short ligne2=(7*ligne)+1,colonne2=(7*colonne)+1;
  //efface la prcedente case et dessine la case clique
	GraySprite8_MASK_R(ligne2, colonne2, 7, case_inverse_light, case_inverse_dark, case_mask, case_mask, GetPlane(LIGHT_PLANE), GetPlane(DARK_PLANE));
	DrawChar(ligne2+2,colonne2+1,texte,A_NORMAL);
}

//////////////////////////////////////////////////////////////////////////////////
BOOL perso (void)
{

   int option=1,y2=40,buffer;
	 void *kbq = kbd_queue ();
	 unsigned char RepetitionFlag,str[5],msg[50];


	 ClrScr();
   FontSetSys(F_8x10);
 	 DrawStr(_fr_eng(30,54),10,_fr_eng("PERSONALISER","CUSTOM"),A_NORMAL);
   FontSetSys(F_6x8);
   WIN_RECT opRec={_fr_eng(25,49),5,_fr_eng(131,107),25};
   DrawClipRect(&opRec,&ECRAN,A_NORMAL | B_DOUBLE | B_CUT);
	 printf_xy(0,40,_fr_eng(">Nb de lignes? %d",">Nb of lines? %d"),nbr_ligne);
	 printf_xy(0,52,_fr_eng(" Nb de colonnes? %d"," Nb of columns? %d"),nbr_colonne);
	 printf_xy(0,64,_fr_eng(" Nb de mines?"," Nb of mines?"));
   if (nbr_ligne*nbr_colonne<10)
    	sprintf(msg,"(max   %d) %d",nbr_ligne*nbr_colonne,nombre_mines);
   else if ((nbr_ligne*nbr_colonne>=10) && (nbr_ligne*nbr_colonne<100))
     	sprintf(msg,"(max  %d) %d",nbr_ligne*nbr_colonne,nombre_mines);
   else
     	sprintf(msg,"(max %d) %d",nbr_ligne*nbr_colonne,nombre_mines);
	 DrawStr(78,64,msg,A_REPLACE);

	do
	{
    key = 0;
    RepetitionFlag = 0;
		while (OSdequeue (&key, kbq))// tant qu'aucune touche n'est appuy
		{
      idle();
			if (OSTimerExpired (APD_TIMER))
			{
		  	off();
		   	OSTimerRestart(APD_TIMER);// Reset APD Timer to its initial value
			}
		}
		OSTimerRestart(APD_TIMER);

    DrawStr(0,y2," ",A_REPLACE);
		if((key == key_enter) || (key == key_esc))
			break;
	  if ((key >= 2345) && (key <= 2392))
	  {
	    RepetitionFlag = 1;	// The key was already pressed just before.
		  key -= 2048;
		}

	  if (key == key_up)  option --;
	  if (key == key_down)  option ++;

		if (RepetitionFlag == 1)				// if key was already pressed just before.
	  {
	    if (option <= 1 ) option = 1;
	    if (option > 3 ) option = 3;
		}
		else														// else, ...
		{
      if (option < 1 ) option = 3;
	    if (option > 3) option = 1;
		}
    y2 = 40 + (12 * (option - 1));
    DrawStr(0,y2,">",A_REPLACE);

    if((option==1)
     &&(key!=key_enter)&&(key!=key_esc)
     &&(key!=key_up)&&(key!=key_down)
     &&(key!=key_off)&&(key!=key_off2))
    {
       buffer=nbr_ligne;
       sprintf(str,"%d",buffer);
       MoveTo(_fr_eng(90,84),40);
		   DrawStr(_fr_eng(90,84),40,"    ",A_REPLACE);
		   Input(str,2);
		   DrawStr(_fr_eng(90,84),40,"    ",A_REPLACE);
		   DrawStr(_fr_eng(90,84),40,str,A_REPLACE);
       nbr_ligne=atoi(str);
       if (nbr_ligne>_89_92(22,33) || nbr_ligne==0)//si le nombre est trop grand
       {
         nbr_ligne=buffer;
         sprintf(str,"%d",nbr_ligne);
		     DrawStr(_fr_eng(90,84),40,"    ",A_REPLACE);
		     DrawStr(_fr_eng(90,84),40,str,A_REPLACE);
       }
     }
     else if((option==2)
           &&(key!=key_enter)&&(key!=key_esc)
           &&(key!=key_up)&&(key!=key_down)
           &&(key!=key_off)&&(key!=key_off2))
     {
       buffer=nbr_colonne;
       sprintf(str,"%d",buffer);
		   MoveTo(_fr_eng(102,96),52);
		   DrawStr(_fr_eng(102,96),52,"    ",A_REPLACE);
		   Input(str,2);
		   DrawStr(_fr_eng(102,96),52,"    ",A_REPLACE);
    	 DrawStr(_fr_eng(102,96),52,str,A_REPLACE);
       nbr_colonne = atoi(str);
       if (nbr_colonne>_89_92(13,17) || nbr_colonne==0)
       {
		     nbr_colonne=buffer;
         sprintf(str,"%d",nbr_colonne);
		     DrawStr(_fr_eng(102,96),52,"    ",A_REPLACE);
		     DrawStr(_fr_eng(102,96),52,str,A_REPLACE);
       }
     }
     else if((option==3)
     			 &&(key!=key_enter)&&(key!=key_esc)
           &&(key!=key_up)&&(key!=key_down)
           &&(key!=key_off)&&(key!=key_off2))
     {
       buffer=nombre_mines;
       sprintf(str,"%d",buffer);
  		 MoveTo(138,64);
	  	 DrawStr(138,64,"    ",A_REPLACE);
		   Input(str,3);
		   DrawStr(138,64,"    ",A_REPLACE);
  	   DrawStr(138,64,str,A_REPLACE);
       nombre_mines = atoi(str);

       if (nombre_mines>(nbr_ligne*nbr_colonne) || nombre_mines==0)
       {
         nombre_mines=buffer;
         sprintf(str,"%d",nombre_mines);
		     DrawStr(138,64,"    ",A_REPLACE);
		     DrawStr(138,64,str,A_REPLACE);
       }
     }

     if (nbr_ligne*nbr_colonne<10)
      	sprintf(msg,"(max   %d) %d",nbr_ligne*nbr_colonne,nombre_mines);
     else if ((nbr_ligne*nbr_colonne>=10) && (nbr_ligne*nbr_colonne<100))
       	sprintf(msg,"(max  %d) %d",nbr_ligne*nbr_colonne,nombre_mines);
     else
       	sprintf(msg,"(max %d) %d",nbr_ligne*nbr_colonne,nombre_mines);
		 DrawStr(78,64,msg,A_REPLACE);

     if (nombre_mines>(nbr_ligne*nbr_colonne))
     {
       nombre_mines=nbr_ligne*nbr_colonne;
       sprintf(str,"%d",nombre_mines);
		   DrawStr(138,64,"    ",A_REPLACE);
		   DrawStr(138,64,str,A_REPLACE);
     }
	   if ((key == key_off) || (key == key_off2))
	      off();   // Turns the calculator off

	  }while ((key != key_enter)&&(key != key_esc));
	  if(key==key_esc)
	  	return FALSE;
	  ClrScr();
		return TRUE;

}

//////////////////////////////////////////////////////////////////////////////////////
void menu(void)
{
	short result,resultat;
  ClrScr();
	FontSetSys(F_8x10);
	DrawStr(0,0,"Demine V0.6",A_REPLACE);
	FontSetSys(F_6x8);
	DrawStr(90,2,"by C.Gallet",A_REPLACE);
	HANDLE menu2 = PopupNew ("DEMINE", 60);
  PopupAddText (menu2, 0, _fr_eng("Jouer","Play"), 1);
  PopupAddText (menu2, 1, _fr_eng("Dbutant","Beginner"), 11);
  PopupAddText (menu2, 1, _fr_eng("Intermdiaire","Intermediate"), 12);
  PopupAddText (menu2, 1, "Expert", 13);
  PopupAddText (menu2, 1, _fr_eng("Personaliser","Custom"), 14);
  PopupAddText (menu2, -1, "Scores", 2);
  PopupAddText (menu2, -1, _fr_eng("A propos","About"), 3);
  PopupAddText (menu2, -1, _fr_eng("Quitter","Quit"), 4);
  result = PopupDo (menu2, CENTER, CENTER, 0);
  HeapFree (menu2);
  if (result == 2)
  {
  	afficher_records();
  	menu();
  }
  if (result == 3)
  {
  	about();
  	menu();
  }
  ClrScr();
  difficulte = 0;
  if (result == 4 || !result)
  {
  	LCD_restore(ecran);
  	ST_helpMsg(MESSAGE);
  	redo=0;
    exit(0);
  }
  else if (result == 11)
  {
    difficulte = 1;
  	nbr_ligne = 6;
  	nbr_colonne = 5;
  	nombre_mines = 3;
  }
  else if (result == 12)
  {
    difficulte = 2;
    nbr_ligne = _89_92(12,16);
    nbr_colonne = _89_92(9,12);
  	nombre_mines = _89_92(15,19);
  }
  else if (result == 13)
  {
    difficulte = 3;
    nbr_ligne = _89_92(22,33);
    nbr_colonne = _89_92(13,17);
    nombre_mines = _89_92(45,60);
  }
  else if (result == 14)
  {
  	resultat=perso();
  	if (resultat == FALSE)
  		menu();
  }

}

//////////////////////////////////////////////////////////////////////////////////
void quit(void)
{
	free(dem);
	free(tab_info);
	nbr_ligne=0;
	nbr_colonne=0;
	nombre_mines=0;
	redo=1;
	_main();
}

//////////////////////////////////////////////////////////////////////////////////
void draw(void)//dessine l'ecran initial
{
  short i,j,k;
  FontSetSys(F_6x8);
  for (i=1 ; i<nbr_ligne*7 ; i = i+7)
	  for (j=1 ; j<nbr_colonne*7 ; j = j+7)
    	GraySprite8_OR_R(i, j, 7, case_light, case_dark, GetPlane(LIGHT_PLANE), GetPlane(DARK_PLANE));
 	for (k=0 ; k<2 ; k++)
 	{
 		GraySetAMSPlane(k);
    DrawClipRect(&(WIN_RECT){0,0,(nbr_ligne*7)+2,(nbr_colonne*7)+2},&ECRAN,A_REPLACE);
    //DrawClipRect(&(WIN_RECT){-1,-1,(nbr_ligne*7)+1,(nbr_colonne*7)+1},&ECRAN,A_REVERSE);
 	}

}

/////////////////////////////////////////////////////////////////////////////////
void perdu(void)
{
  short i,j;
  unsigned char case_mines[] = {
	0x00,0x4A,0x30,0x32,0x48,0x02,0x54
  };
  for (i=0 ; i<nbr_ligne ; i++)
   	for (j=0 ; j<nbr_colonne ; j++)
      if(dem[i][j] == 9)
      {
   	  	Sprite8_AND_R((7*i)+1,(7*j)+1,7,case_mask,GetPlane(DARK_PLANE));//efface la case
				GraySprite8_OR_R((7*i)+1, (7*j)+1, 7, case_mines, case_mines, GetPlane(LIGHT_PLANE), GetPlane(DARK_PLANE));
      }

  WINDOW perdu_light,perdu_dark;
  WIN_RECT win_perdu={_89_92(45,85), _89_92(45,59), _89_92(107,147), _89_92(59,73)};
  SCR_RECT rect2={{_89_92(46,86), _89_92(46,60), _89_92(106,146), _89_92(58,72)}};
  GraySetAMSPlane(LIGHT_PLANE);
	 	WinOpen (&perdu_light, &win_perdu , WF_SAVE_SCR | WF_TTY);
		WinActivate (&perdu_light);
		WinFont(&perdu_light, F_8x10);
		WinStr (&perdu_light, _fr_eng("PERDU!!","LOST!!!"));
		ScrRectFill(&rect2 ,&ECRAN,A_XOR);
  GraySetAMSPlane(DARK_PLANE);
	 	WinOpen (&perdu_dark, &win_perdu, WF_SAVE_SCR | WF_TTY);
		WinActivate (&perdu_dark);
		WinFont(&perdu_dark, F_8x10);
		WinStr (&perdu_dark, _fr_eng("PERDU!!","LOST!!!"));
		ScrRectFill(&rect2,&ECRAN,A_XOR);
  idle();//economise les piles
  ngetchx ();
  WinClose (&perdu_light);
  WinClose (&perdu_dark);
  SetIntVec (AUTO_INT_5, OldInt5);
  GrayOff();
  quit();
}

///////////////////////////////////////////////////////////////////////////////////
void explore(short ligne,short colonne)//une fonction recursive decouvrant les cases adjacentes
{
  long (*test)=NULL;
TRY
	test=malloc(1500);
	if(test==NULL)
	{
		free(test);
	  GrayOff();
		free(dem);
		free(tab_info);
		LCD_restore(ecran);
    DlgMessage("ERREUR","memoire",BT_CANCEL,BT_SAVE);//affiche l'erreur
	  ST_helpMsg(MESSAGE);
	  redo=0;
	 	SetIntVec (AUTO_INT_5, OldInt5);
		exit(0);
	}
	free(test);
  if (ligne+1 < nbr_ligne){
	  if (!dem[ligne+1][colonne] && tab_info[ligne+1][colonne]!=3 && tab_info[ligne+1][colonne]!=2)
	  {
      draw_box(ligne+1,colonne,' ');
	    tab_info[ligne+1][colonne]=3;
	    score++;
	    explore(ligne+1,colonne);
	  }else if (dem[ligne+1][colonne] && tab_info[ligne+1][colonne]!=2)
	  {
	    draw_box(ligne+1,colonne,(char)(dem[ligne+1][colonne]+48));
	    if (tab_info[ligne+1][colonne] != 1) score++;
	  	tab_info[ligne+1][colonne]=1;
	  }
	}

  if (ligne-1 >= 0){
	  if (!dem[ligne-1][colonne] && tab_info[ligne-1][colonne]!=3 && tab_info[ligne-1][colonne]!=2)
	  {
	    draw_box(ligne-1,colonne,' ');
	    tab_info[ligne-1][colonne]=3;
	    score++;
	    explore(ligne-1,colonne);
	  }else if (dem[ligne-1][colonne] && tab_info[ligne-1][colonne]!=2)
	  {
	    draw_box(ligne-1,colonne,(char)(dem[ligne-1][colonne]+48));
	    if (tab_info[ligne-1][colonne] != 1) score++;
	  	tab_info[ligne-1][colonne]=1;
	  }
	}

  if (colonne+1 < nbr_colonne){
	  if (!dem[ligne][colonne+1] && tab_info[ligne][colonne+1]!=3 && tab_info[ligne][colonne+1]!=2)
	  {
	    draw_box(ligne,colonne+1,' ');
	    tab_info[ligne][colonne+1]=3;
	    score++;
	    explore(ligne,colonne+1);
	  }else if (dem[ligne][colonne+1] && tab_info[ligne][colonne+1]!=2)
	  {
	    draw_box(ligne,colonne+1,(char)(dem[ligne][colonne+1]+48));
	    if (tab_info[ligne][colonne+1] != 1) score++;
	  	tab_info[ligne][colonne+1]=1;
	  }
	}

  if (colonne-1 >= 0){
	  if (!dem[ligne][colonne-1] && tab_info[ligne][colonne-1]!=3 && tab_info[ligne][colonne-1]!=2)
	  {
	    draw_box(ligne,colonne-1,' ');
      tab_info[ligne][colonne-1]=3;
			score++;
	    explore(ligne,colonne-1);
	  }else if (dem[ligne][colonne-1] && tab_info[ligne][colonne-1]!=2)
	  {
	    draw_box(ligne,colonne-1,(char)(dem[ligne][colonne-1]+48));
 	    if (tab_info[ligne][colonne-1] != 1) score++;
	  	tab_info[ligne][colonne-1]=1;
	  }
	}

  if (ligne+1 < nbr_ligne && colonne+1 < nbr_colonne){
    if (!dem[ligne+1][colonne+1] && tab_info[ligne+1][colonne+1]!=3 && tab_info[ligne+1][colonne+1]!=2)
	  {
	    draw_box(ligne+1,colonne+1,' ');
      tab_info[ligne+1][colonne+1]=3;
			score++;
	    explore(ligne+1,colonne+1);
	  }else if (dem[ligne+1][colonne+1] && tab_info[ligne+1][colonne+1]!=2)
    {
	    draw_box(ligne+1,colonne+1,(char)(dem[ligne+1][colonne+1]+48));
 	    if (tab_info[ligne+1][colonne+1] != 1) score++;
	  	tab_info[ligne+1][colonne+1]=1;
    }
  }

  if (ligne-1 >= 0 && colonne+1 < nbr_colonne){
    if (!dem[ligne-1][colonne+1] && tab_info[ligne-1][colonne+1]!=3 && tab_info[ligne-1][colonne+1]!=2)
	  {
	    draw_box(ligne-1,colonne+1,' ');
      tab_info[ligne-1][colonne+1]=3;
			score++;
	    explore(ligne-1,colonne+1);
	  }else if (dem[ligne-1][colonne+1] && tab_info[ligne-1][colonne+1]!=2)
    {
	    draw_box(ligne-1,colonne+1,(char)(dem[ligne-1][colonne+1]+48));
 	    if (tab_info[ligne-1][colonne+1] != 1) score++;
	  	tab_info[ligne-1][colonne+1]=1;
    }
  }

  if (ligne+1 < nbr_ligne && colonne-1 >= 0){
 	  if (!dem[ligne+1][colonne-1] && tab_info[ligne+1][colonne-1]!=3 && tab_info[ligne+1][colonne-1]!=2)
	  {
	    draw_box(ligne+1,colonne-1,' ');
      tab_info[ligne+1][colonne-1]=3;
			score++;
	    explore(ligne+1,colonne-1);
	  }else if (dem[ligne+1][colonne-1] && tab_info[ligne+1][colonne-1]!=2)
    {
	    draw_box(ligne+1,colonne-1,(char)(dem[ligne+1][colonne-1]+48));
 	    if (tab_info[ligne+1][colonne-1] != 1) score++;
	  	tab_info[ligne+1][colonne-1]=1;
    }
  }

  if (ligne-1 >= 0 && colonne-1 >= 0){
 	  if (!dem[ligne-1][colonne-1] && tab_info[ligne-1][colonne-1]!=3 && tab_info[ligne-1][colonne-1]!=2)
	  {
	    draw_box(ligne-1,colonne-1,' ');
      tab_info[ligne-1][colonne-1]=3;
			score++;
	    explore(ligne-1,colonne-1);
	  }else if (dem[ligne-1][colonne-1] && tab_info[ligne-1][colonne-1]!=2)
    {
	    draw_box(ligne-1,colonne-1,(char)(dem[ligne-1][colonne-1]+48));
 	    if (tab_info[ligne-1][colonne-1] != 1) score++;
	  	tab_info[ligne-1][colonne-1]=1;
    }
  }
ONERR//si la fonction a eu 1 problme
  GrayOff();
  DlgMessage("ERREUR",find_error_message (errCode),BT_CANCEL,BT_SAVE);//affiche l'erreur
  LCD_restore(ecran);
	free(dem);
	free(tab_info);
  ST_helpMsg(MESSAGE);
  redo=0;
  SetIntVec (AUTO_INT_5, OldInt5);
  exit(0);
ENDTRY
}

/////////////////////////////////////////////////////////////////////////////////
void gagne(void)
{
  char message[20],position[3][10]={_fr_eng("premire","first"),_fr_eng("deuxime","second"),_fr_eng("troisime","third")};
  short i,j;
  WIN_RECT input={38,60,114,74};
  SetIntVec (AUTO_INT_5, OldInt5);
  status();
  sprintf(message,_fr_eng("GAGNE!!\n  en\n%ds","WON!!\n  in\n%ds"),Counter);
  WINDOW gagne_light,gagne_dark;
  WIN_RECT win_gagne={_fr_eng(40,46), 35, _fr_eng(102,96), 72};
  SCR_RECT rect2={{_fr_eng(41,47), 36, _fr_eng(101,95), 71}};
  GraySetAMSPlane(LIGHT_PLANE);
	  WinOpen (&gagne_light, &win_gagne , WF_SAVE_SCR | WF_TTY);
	  WinActivate (&gagne_light);
	  WinFont(&gagne_light, F_8x10);
	  WinStr (&gagne_light, message);
	  ScrRectFill(&rect2 ,&ECRAN,A_XOR);
  GraySetAMSPlane(DARK_PLANE);
	  WinOpen (&gagne_dark, &win_gagne, WF_SAVE_SCR | WF_TTY);
	  WinActivate (&gagne_dark);
	  WinFont(&gagne_dark, F_8x10);
	  WinStr (&gagne_dark, message);
	  ScrRectFill(&rect2,&ECRAN,A_XOR);
  idle();
  ngetchx ();
  WinClose (&gagne_light);
  WinClose (&gagne_dark);
  GrayOff();
  if (difficulte)
  {
    ClrScr();
    FontSetSys(F_8x10);
    DrawStr(25,20,_fr_eng("Congratulations","Felicitation!"),A_REPLACE);
    FontSetSys(F_6x8);
    DrawStr(20,38,_fr_eng("Vous tes plac en","You come in"),A_REPLACE);
    for (i=0 ; i<=2 ; i++)
    {
     	if (difficulte == 1){
	   		if (Counter < record_debutant[i].temps)
	   		{
					for (j = 1 ;j>=i ; j--)
					{
					  record_debutant[i+j+1].temps=record_debutant[i+j].temps;
						strcpy(record_debutant[i+j+1].nom,record_debutant[i+j].nom);
					}
          MoveTo(20,48);
          printf("%s position",position[i]);
          DrawClipRect(&input,&ECRAN,B_DOUBLE | A_NORMAL);
	  		  input_str(record_debutant[i].nom,40,64,10);
	        record_debutant[i].temps=Counter;
	        break;
	   		}
     	}
		  else if (difficulte == 2){
			  if (Counter < record_intermediaire[i].temps)
			  {
					for (j = 1 ;j>=i ; j--)
					{
					  record_intermediaire[i+j+1].temps=record_intermediaire[i+j].temps;
						strcpy(record_intermediaire[i+j+1].nom,record_intermediaire[i+j].nom);
					}
          MoveTo(20,48);
          printf("%s position",position[i]);
          DrawClipRect(&input,&ECRAN,B_DOUBLE | A_NORMAL);
			    input_str(record_intermediaire[i].nom,40,64,10);
					record_intermediaire[i].temps=Counter;
	        break;
			  }
  		}
	  	else if (difficulte == 3){
		  if (Counter < record_expert[i].temps)
			  {
					for (j = 1 ;j>=i ; j--)
					{
					  record_expert[i+j+1].temps=record_expert[i+j].temps;
						strcpy(record_expert[i+j+1].nom,record_expert[i+j].nom);
					}
          MoveTo(20,48);
          printf("%s position",position[i]);
          DrawClipRect(&input,&ECRAN,B_DOUBLE | A_NORMAL);
			    input_str(record_expert[i].nom,40,64,10);
			  	record_expert[i].temps=Counter;
	        break;
			  }
  		}
    }
		ClrScr();
		highscore(WRITE);//ecris les nouveaux records
  }
  quit();
}

////////////////////////////////////////////////////////////////////////////////////
void _main(void)//la fonction principale
{
  short i;
  short ligne=0,colonne=0;//coordones dans la matrice
  short tmp_num;
  static unsigned char flag[] = {
  0x00,0x38,0x24,0x38,0x20,0x20,0x00
  };//1drapeau!
  if (!redo)//ne s'execute qu'1 fois au lancement du programme
  {
  	randomize();//initialise le gnerateur de nombre alatoire
		key_off2=KEY_OFF2,key_up=KEY_UP,key_down=KEY_DOWN;
    LCD_save(ecran);
  }
  //initialisation des variables
  redo=1;
  score=0;
  Counter=0;
  count2=0;
  x=1;
  y=1;
  OldInt5 = GetIntVec (AUTO_INT_5);

  record_debutant[0]=(RECORD){"---------",600};record_debutant[1]=(RECORD){"---------",600};
  record_debutant[2]=(RECORD){"---------",600};
  record_intermediaire[0]=(RECORD){"---------",600};record_intermediaire[1]=(RECORD){"---------",600};
  record_intermediaire[2]=(RECORD){"---------",600};
  record_expert[0]=(RECORD){"---------",600};record_expert[1]=(RECORD){"---------",600};
  record_expert[2]=(RECORD){"---------",600};

  nb_de_drapeaux=0;
  highscore(READ);//read
  menu();
  highscore(WRITE);//write
  FontSetSys(F_8x10);
  DrawStr(_fr_eng(0,24),45,_fr_eng("Cration des donnes","Datas creation"),A_REPLACE);
  FontSetSys(F_6x8);

  create();//cre une matrice alatoire
  GrayOn();
  draw();
  SetIntVec (AUTO_INT_5, MyInt5);

  do
  {
    status();
    mouse();
    status();
    //'conversion' des coordones,x et y,du pointeur
    for (i=0 ; i<(nbr_ligne) ; i++)
    	if ((x>=7*i) && (x<=(i+1)*7))
    	{
    		ligne=i;
    		break;
    	}
    for (i=0 ; i<(nbr_colonne) ; i++)
    	if ((y>=7*i) && (y<=(i+1)*7))
    	{
    		colonne=i;
    		break;
    	}

    tmp_num=tab_info[ligne][colonne];
    if(key == KEY_APPS)//affiche l'aide
    {
      help();
      continue;
    }else if (key == key_enter || key == KEY_F2)//affiche le contenu de la case
    {
			if (tmp_num!=2)
			{
        if (dem[ligne][colonne] != 9)
        {
          if (tmp_num == 0)
            score++;
          if (dem[ligne][colonne]==0)
          {
           	tab_info[ligne][colonne]=3;
 						draw_box(ligne,colonne,' ');
           	explore(ligne,colonne);
          }else{
            tab_info[ligne][colonne]=1;
        	  draw_box(ligne,colonne,(char)(dem[ligne][colonne]+48));
          }
        }else{
        	perdu();
        }

      }
    }else if(key==KEY_F1)//pose 1 drapeaux
    	if ((tmp_num != 1) && (tmp_num != 3))
    	{
    		if (tmp_num == 2)
    		{
					GraySprite8_MASK_R((7*ligne)+1, (7*colonne)+1, 7, case_light, case_dark, case_mask, case_mask, GetPlane(LIGHT_PLANE), GetPlane(DARK_PLANE));
    			tab_info[ligne][colonne]=0;
    			nb_de_drapeaux--;
    		}else if (nb_de_drapeaux<nombre_mines){
				   GraySprite8_OR_R((7*ligne)+1, (7*colonne)+1, 7, flag, flag, GetPlane(LIGHT_PLANE), GetPlane(DARK_PLANE));
	    		 tab_info[ligne][colonne]=2;
					 nb_de_drapeaux++;
	    	}
	    }
	  if (score >= (nbr_ligne*nbr_colonne)-nombre_mines)
    gagne();
  }while (key != key_esc);
  SetIntVec (AUTO_INT_5, OldInt5);
  GrayOff();
  quit();
}